from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from StringIO import StringIO
from Products.CMFCore.utils import getToolByName

import Products.GenericPloneContent.GenericPloneContent
from Products.GenericPloneContent.config import *

def install(self):
    out = StringIO()
    installer = getToolByName(self, 'portal_quickinstaller')
    if not installer.isProductInstalled('ATSchemaEditorNG'):
    	if installer.isProductInstallable('ATSchemaEditorNG'):
		installer.installProduct('ATSchemaEditorNG')
	else:
		raise 'ATSchemaEditorNG is required to installa Generic Plone Content'
	
    installTypes(self, out, listTypes(PROJECTNAME), PROJECTNAME)

    install_subskin(self, out, GLOBALS)
    self.portal_actions.manage_aproviders(apname="portal_schemamanager", add_provider=1, REQUEST=None)
    self.manage_addProduct['GenericPloneContent'].manage_addTool(type='Schema Manager Tool')
    portal_conf=getToolByName(self,'portal_controlpanel')
    #portal_conf.unregisterConfiglet('SchemaManager')
    portal_conf.registerConfiglet( 'SchemaManager'
                 , 'Schema Manager'      
                 , 'string:${portal_url}/portal_schemamanager/schemamanager_configlet' 
                 , ''                   # a condition   
                 , 'Manage portal'      # access permission
                 , 'Products'           # section to which the configlet should be added: 
                                        #(Plone,Products,Members) 
                 , 1                    # visibility
                 , 'GenericPloneContent'
                 , 'SchemaManager.jpg' # icon in control_panel, put your own icon in the 
                                                # /skins folder of your product and change 
                                                #'site_icon.gif' to 'yourfile'
                 , 'Manage the creation of new object'
                 , None
                 )
		 
    container_type_name="Generic Container"
    
    portal_schemamanager=getToolByName(self,'portal_schemamanager')
    #portal_schemamanager.setTitle('Schema manager')
    portal_schemamanager.manage_addProperty('right_slots',[],'lines')
    precreated_models=portal_schemamanager.precreated_models
    for model in precreated_models:
    	portal_schemamanager.manage_addProduct['GenericPloneContent'].manage_addContent(model,container_type_name)
	#import pdb;pdb.set_trace()
	class_name_list=model.split()
	class_name=''.join(class_name_list)
	portal_schemamanager[model].registerObjectSchema(class_name)
	for k, v in STORAGE_REGISTRY_INFO:
		portal_schemamanager[model].atse_registerStorage(k,storage=v['storage'],visible=v['visible'])

    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()

def uninstall(self):
   out=StringIO()
   portal_conf=getToolByName(self,'portal_controlpanel')
   portal_conf.unregisterConfiglet('SchemaManager')
   self.portal_actions.manage_aproviders(chosen=('portal_schemamanager',), del_provider=1)
   return out.getvalue()
