from Globals import package_home
from Products.Archetypes.public import *
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
import os, os.path

from config import *


registerDirectory(SKINS_DIR, GLOBALS)

import SchemaManagerTool

tools = (SchemaManagerTool.SchemaManagerTool, )


def initialize(context):

    ##Import Types here to register them
    import GenericPloneContent
    import GenericContainer
    utils.ToolInit('Schema Manager Tool', tools=tools,
                product_name='GenericPloneContent', icon="tool.jpg").initialize(context)
    
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types      = content_types,
        permission         = ADD_CONTENT_PERMISSION,
        extra_constructors = constructors,
        fti                = ftis,
        ).initialize(context)

